const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const pages = sequelize.define(
    'pages',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

title: {
        type: DataTypes.TEXT,
      
      

      },

slug: {
        type: DataTypes.TEXT,
      
      

      },

path: {
        type: DataTypes.TEXT,
      
      

      },

published: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

publish_start: {
        type: DataTypes.DATE,
      
      

      },

publish_end: {
        type: DataTypes.DATE,
      
      

      },

seo_description: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  pages.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









    db.pages.hasMany(db.layers, {
      as: 'layers_page',
      foreignKey: {
          name: 'pageId',
      },
      constraints: false,
    });



    db.pages.hasMany(db.versions, {
      as: 'versions_page',
      foreignKey: {
          name: 'pageId',
      },
      constraints: false,
    });


    db.pages.hasMany(db.builds, {
      as: 'builds_page',
      foreignKey: {
          name: 'pageId',
      },
      constraints: false,
    });





//end loop



    db.pages.belongsTo(db.projects, {
      as: 'project',
      foreignKey: {
        name: 'projectId',
      },
      constraints: false,
    });

    db.pages.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.pages.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.pages.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return pages;
};


